#!/bin/bash
#
# Copyright (C) 2017 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

if [ ! -d /etc/dehydrated/certs ]; then exit 1 ; fi
if [ ! -x /usr/bin/which    ] ; then exit 2; fi
if ! which ssl-cert-check  >/dev/null 2>&1; then exit 3; fi
if ! which gawk            >/dev/null 2>&1; then exit 4; fi
cd /etc/dehydrated/certs/
for DOMAIN in * ; do 
	error=0; trap 'error=$(($?>$error?$?:$error))' ERR
	state=$( ssl-cert-check -b -n -s ${DOMAIN} -p 443 -x 20 )
	formattedstate=$(gawk '{print "Certificate_" $1 " - " $2,$3,$4,$5,$6 }' <<<$state )
	if [ $DOMAIN == "*" ]; then exit 5; fi
	echo ${error} ${formattedstate}
done
